; 
    include     masm32rt.inc    ; defaults to .386
.586
    include     timers.asm      ; requires a pentium
; 
    ByteText    proto
    StrLen1     proto   :DWORD
    StrLen2     proto   :DWORD
    szLen1      proto   :DWORD
    szLen2      proto   :DWORD
    szLen3      proto   :DWORD
    szLen4      proto   :DWORD
; 
.data
align 4
    str0        db 0
align 4
    str1        db 'X',0
align 4
    str2        db 'XX',0
align 4
    str3        db 'XXX',0
    str4        db 'XXXX',0
align 4
    str5        db 'XXXXX',0
align 4
    str15       db 15 dup('X'),0
align 4
    str16       db 16 dup('X'),0
align 4
    str17       db 17 dup('X'),0
align 4
    str255      db 255 dup('X'),0
align 4
    str1023     db 1023 dup('X'),0
align 4
    StrList     db  "0",0,0,0,"1",0,0,0,"2",0,0,0,"3",0,0,0,"4",0,0,0,\
                    "5",0,0,0,"15",0,0,"16",0,0,"17",0,0,"255",0,"1023",0
align 4
    pStrList    dd 0
    hHnd        dd 0
    cPos        COORD<0,1>
.code
; 
start:
; 
    invoke GetStdHandle,STD_OUTPUT_HANDLE
    mov hHnd, eax
    m2m pStrList,offset StrList     ; make a pointer to text
    
    cls
    print chr$("            StrLen StrLen1 StrLen2 szLen szLen1 szLen2 szLen3 szLen4 lstrlen",13,10)
    
    FOR teststr,<str0,str1,str2,str3,str4,str5,str15,str16,str17,str255,str1023>
        invoke ByteText         ; generate string length text
        FOR testproc,<StrLen,StrLen1,StrLen2,szLen,szLen1,szLen2,szLen3,szLen4,lstrlen>
        ; "crt_strlen" would not run for me
            counter_begin 10000000, HIGH_PRIORITY_CLASS
                invoke testproc,ADDR teststr
            counter_end
            print ustr$(eax)
            invoke SetConsoleCursorPosition,hHnd,dword ptr cPos
            add [cPos.x],7      ; makes nice spacing
            invoke Sleep,250    ; short break to let Windows stabilize
        ENDM
        mov [cPos.x],0          ; CR+LF
        inc [cPos.y]
        invoke SetConsoleCursorPosition,hHnd,dword ptr cPos
    ENDM
    mov   eax,input(13,10,"Press enter to exit...")
    exit
; 


ByteText proc                   ; prints length of string being tested
    print dword ptr pStrList    ; output text
    print chr$(" bytes:")
    add pStrList,4              ; increment pointer offset
    mov [cPos.x],14             ; space properly
    invoke SetConsoleCursorPosition,hHnd,dword ptr cPos
    add [cPos.x],8
    ret
ByteText EndP



OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

align 4

StrLen1 proc item:DWORD

    push    ebx

    mov     eax, [esp+2*4]          ; get pointer to string
    lea     edx, [eax+3]            ; pointer+3 used in the end
align 4
@@:
    mov     ebx, [eax]              ; read first 4 bytes
    add     eax, 4                  ; increment pointer
    lea     ecx, [ebx-01010101h]    ; subtract 1 from each byte
    not     ebx                     ; invert all bytes
    and     ecx, ebx                ; and these two
    and     ecx, 80808080h
    jz      @B                      ; no zero bytes, continue loop

    test    ecx, 00008080h          ; test first two bytes
    jnz     @F

    shr     ecx, 16                 ; not in the first 2 bytes
    add     eax, 2

@@:
    shl     cl, 1                   ; use carry flag to avoid branch
    sbb     eax, edx                ; compute length

    pop     ebx

    ret     1*4

StrLen1 endp

align 4

StrLen2 proc src:DWORD

    mov     ecx, [esp+1*4]
    test    ecx, 3
    jz      @max8

@bucle:
    mov     al, [ecx]
    add     ecx, 1
    test    al, al
    jz      @lb1

    test    ecx, 3
    jnz     @bucle
align 4
@max8:
    mov     eax, [ecx]
    mov     edx, 7EFEFEFFh
    add     edx, eax
    xor     eax, 0FFFFFFFFh
    xor     eax, edx
    add     ecx, 4
    test    eax, 81010100h
    jz      @max8

    mov     eax, [ecx-4]
    test    al, al
    jz      @lb4

    test    ah, ah
    jz      @lb3

    test    eax, 0FF0000h
    jz      @lb2

    test    eax, 0FF000000h
    jnz     @max8

@lb1:
    lea     eax, [ecx-1]
    mov     ecx, [esp+1*4]
    sub     eax, ecx
    ret     1*4

@lb2:
    lea     eax, [ecx-2]
    mov     ecx, [esp+1*4]
    sub     eax, ecx
    ret     1*4

@lb3:
    lea     eax, [ecx-3]
    mov     ecx, [esp+1*4]
    sub     eax, ecx
    ret     1*4

@lb4:
    lea     eax, [ecx-4]
    mov     ecx, [esp+1*4]
    sub     eax, ecx
    ret     1*4

StrLen2 endp

align 4

szLen1 proc src:DWORD

    mov     eax, [esp+1*4]    ; src
    sub     eax, 4
align 4
@@:
    add     eax, 4
    cmp     BYTE PTR [eax], 0
    je      @lb1

    cmp     BYTE PTR [eax+1], 0
    je      @lb2

    cmp     BYTE PTR [eax+2], 0
    je      @lb3

    cmp     BYTE PTR [eax+3], 0
    jne     @B

    sub     eax, [esp+1*4]    ; src
    add     eax, 3
    ret     1*4

@lb3:
    sub     eax, [esp+1*4]    ; src
    add     eax, 2
    ret     1*4

@lb2:
    sub     eax, [esp+1*4]    ; src
    add     eax, 1
    ret     1*4

@lb1:
    sub     eax, [esp+1*4]    ; src
    ret     1*4

szLen1 endp

align 4

szLen2 proc src:DWORD

    mov     eax, [esp+1*4]    ; src
    sub     eax, 4
    xor     ecx, ecx
align 4
@@:
    add     eax, 4
    cmp     BYTE PTR [eax], cl
    je      @lb1

    cmp     BYTE PTR [eax+1], cl
    je      @lb2

    cmp     BYTE PTR [eax+2], cl
    je      @lb3

    cmp     BYTE PTR [eax+3], cl
    jne     @B

    sub     eax, [esp+1*4]    ; src
    add     eax, 3
    ret     1*4

@lb3:
    sub     eax, [esp+1*4]    ; src
    add     eax, 2
    ret     1*4

@lb2:
    sub     eax, [esp+1*4]    ; src
    add     eax, 1
    ret     1*4

@lb1:
    sub     eax, [esp+1*4]    ; src
    ret     1*4

szLen2 endp

align 4

szLen3 proc src:DWORD

    mov     eax, [esp+1*4]    ; src
    sub     eax, 4
    xor     ecx, ecx
align 4
@@:
    add     eax, 4
    mov     ecx, [eax]
    ;cmp    BYTE PTR [eax], 0
    test    cl, cl
    je      @lb1

    ;cmp    BYTE PTR [eax+1], 0
    test    ch, ch
    je      @lb2

    mov     ecx, [eax+2]
    ;cmp    BYTE PTR [eax+2], 0
    test    cl, cl
    je      @lb3

    ;cmp    BYTE PTR [eax+3], 0
    test    ch, ch
    jne     @B

    sub     eax, [esp+1*4]    ; src
    add     eax, 3
    ret     1*4

@lb3:
    sub     eax, [esp+1*4]    ; src
    add     eax, 2
    ret     1*4

@lb2:
    sub     eax, [esp+1*4]    ; src
    add     eax, 1
    ret     1*4

@lb1:
    sub     eax, [esp+1*4]    ; src
    ret     1*4

szLen3 endp

align 4

szLen4 proc src:DWORD

    mov     eax, [esp+1*4]    ; src
    sub     eax, 4
    ;xor    ecx, ecx
align 4
@@:
    add     eax, 4
    movzx   ecx, word ptr [eax]
    ;cmp    BYTE PTR [eax], 0
    test    cl, cl
    je      @lb1

    ;cmp    BYTE PTR [eax+1], 0
    test    ch, ch
    je      @lb2

    movzx   ecx, word ptr [eax+2]
    ;cmp    BYTE PTR [eax+2], 0
    test    cl, cl
    je      @lb3

    ;cmp    BYTE PTR [eax+3], 0
    test    ch, ch
    jne     @B

    sub     eax, [esp+1*4]    ; src
    add     eax, 3
    ret     1*4

@lb3:
    sub     eax, [esp+1*4]    ; src
    add     eax, 2
    ret     1*4

@lb2:
    sub     eax, [esp+1*4]    ; src
    add     eax, 1
    ret     1*4

@lb1:
    sub     eax, [esp+1*4]    ; src
    ret     1*4

szLen4 endp

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

end start